Biblioteka/Controllers/FineController.cs
using Biblioteka.Models;
using Biblioteka.ModelViews;
using NHibernate;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Biblioteka.Controllers
{
    public class FineController : AuthorizationController

    {
        // GET: Fine
        public ActionResult Index(bool calculate=false)
        {
            try
            {
                if (!IsLogged()) { return RedirectToAction("Login", "Account"); }
                using (ISession session = database.MakeSession())
                {
                    ValidateReaderForbiddenAccess(session);

                    if (calculate)
                    {
                        CalculateFines();
                    }
                    var fines = session.QueryOver<Fine>().Where(x => x.Deleted == false).List();
                    var finesData = new List<FineCopyView>();

                    foreach (var fin in fines)
                    {
                        var fine = new FineCopyView()
                        {
                            Id = fin.Id,
                            CopyId = fin.Copy.Id,
                            Title = fin.Copy.Book.Title,
                            Amount = fin.Amount,
                            Deleted = fin.Deleted,
                            Description = fin.Description

                        };
                        finesData.Add(fine);
                    }

                    return View(finesData);
                }
            }
            catch (UnauthorizedAccessException)
            {
                return RedirectToAction("Forbidden", "Error");
            }
            catch (Exception)
            {
                return RedirectToAction("Index", "Home");
            }
        }

        public ActionResult UserFines()
        {
            try
            {
                if (!IsLogged()) { return RedirectToAction("Login", "Account"); }
                using (ISession session = database.MakeSession())
                {
                    ValidateAdminAndEmployeeForbiddenAccess(session);
                    var reader = GetReader(session);

                    var fines = session.QueryOver<Fine>().Where(x => x.Reader == reader).Where(x => x.Deleted == false).List();
                    var finesData = new List<FineCopyView>();

                    foreach (var fin in fines)
                    {
                        var fine = new FineCopyView()
                        {
                            Id = fin.Id,
                            CopyId = fin.Copy.Id,
                            Title = fin.Copy.Book.Title,
                            Amount = fin.Amount,
                            Deleted = fin.Deleted,
                            Description = fin.Description

                        };
                        finesData.Add(fine);
                    }

                    return View(finesData);
                }
            }
            catch (UnauthorizedAccessException)
            {
                return RedirectToAction("Forbidden", "Error");
            }
            catch (Exception)
            {
                return RedirectToAction("Index", "Home");
            }
        }

        public void CalculateFines()
        {
            using (ISession session = database.MakeSession())
            {
                IList<Rental> currentRentals = session.QueryOver<Rental>().Where(x => x.Deleted == false).List();
                var today = DateTime.Today;

                using (ITransaction transaction = session.BeginTransaction())
                {
                    foreach (var rental in currentRentals)
                    {
                        var dateTo = DateTime.Parse(rental.DateTo);
                        if (dateTo > today) continue;

                        System.TimeSpan diff = today - dateTo;

                        var currentFine = session.QueryOver<Fine>().Where(x => x.Reader == rental.Reader).Where(x => x.Copy == rental.Copy).SingleOrDefault();
                        if (currentFine == null)
                        {
                            var newFine = new Fine()
                            {
                                Copy = rental.Copy,
                                Reader = rental.Reader,
                                Amount = (float)(diff.Days * 0.2),
                                Description = "Delay - days:" + diff.Days,
                                Deleted = false
                            };
                            session.SaveOrUpdate(newFine);
                            session.Flush();
                        }
                        else
                        {

                            currentFine.Amount = (float)(diff.Days * 0.2);
                            currentFine.Description = "Delay - days:" + diff.Days;
                            currentFine.Deleted = false;
                            session.SaveOrUpdate(currentFine);
                            session.Flush();
                        }

                    }
                    transaction.Commit();

                }


            }
        }
    }
}

Biblioteka/Controllers/TagController.cs
using Biblioteka.Models;
using NHibernate;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Biblioteka.Controllers
{
    public class TagController : AuthorizationController
    {
        // GET: Tag
        public ActionResult Index()
        {
            try
            {
                using (ISession session = database.MakeSession())
                {
                    if (!IsLogged()) return RedirectToAction("Login", "Account");
                    ValidateReaderForbiddenAccess(session);
                    var tags = session.QueryOver<Tag>().List();
                    ViewBag.Role = GetRole(session);
                    return View(tags);
                }
            }
            catch (UnauthorizedAccessException)
            {
                return RedirectToAction("Forbidden", "Error");
            }
            catch (Exception)
            {
                return RedirectToAction("Index");
            }
        }

        public ActionResult Create()
        {
            try
            {
                using (ISession session = database.MakeSession())
                {
                    if (!IsLogged()) return RedirectToAction("Login", "Account");
                    ValidateReaderForbiddenAccess(session);
                }
                return View();
            }
            catch (UnauthorizedAccessException)
            {
                return RedirectToAction("Forbidden", "Error");
            }
            catch (Exception)
            {
                return RedirectToAction("Index");
            }
        }

        [HttpPost]
        public ActionResult Create(Tag tag)
        {
            try
            {
                using (ISession session = database.MakeSession())
                {
                    if (ModelState.IsValid)
                    {
                        using (var transaction = session.BeginTransaction())
                        {
                            session.SaveOrUpdate(tag);

                            transaction.Commit();
                            session.Close();

                        }
                        return RedirectToAction("Index");

                    }
                    else
                    {
                        return View(tag);
                    }
                }
            }
            catch (Exception)
            {
                return View();
            }


        }

        public ActionResult Delete(int id)
        {
            try
            {
                if (!IsLogged()) return RedirectToAction("Login", "Account");
                using (ISession session = database.MakeSession())
                {
                    ValidateReaderForbiddenAccess(session);
                    var tag = session.Get<Tag>(id);
                    return View(tag);
                }
            }catch (UnauthorizedAccessException)
            {
                return RedirectToAction("Forbidden", "Error");
            }
            catch (Exception)
            {
                return RedirectToAction("Index");
            }
        }

        [HttpPost]
        public ActionResult Delete(int id, Tag tag)
        {
            try
            {
                using (ISession session = database.MakeSession())
                {
                    using (ITransaction transaction = session.BeginTransaction())
                    {
                        var tagToDelete = session.Get<Tag>(id);
                        session.Delete(tagToDelete);
                        transaction.Commit();

                        session.Close();
                    }
                }
                return RedirectToAction("Index");
            }
            catch (Exception exception)
            {
                return View();
            }
        }

        public JsonResult IsTagNameExist(string name)
        {
            using (ISession session = database.MakeSession())
            {
                bool exists = session.QueryOver<Tag>().Where(x => x.Name == name).RowCount() > 0;
                if (exists)
                {
                    return Json(false, JsonRequestBehavior.AllowGet);
                }
                else
                {
                    return Json(true, JsonRequestBehavior.AllowGet);
                }
            }
        }
    }
}

Biblioteka/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>@ViewBag.Title - My ASP.NET Application</title>
    @Styles.Render("~/Content/css")
    @Scripts.Render("~/bundles/modernizr")
    <link href="~/Content/Site.css" rel="stylesheet" />
</head>
<body>


    <div class="">
        <div class="main main_color ">
            <div class="col-md-2"></div>
            <div class="col-md-8">

                <table style="margin-left:10px;">
                    <tr>
                        <td>
                            <img src="/images/red_book.png" alt="Sample Photo" width="80" height="80" />
                        </td>
                        <td>
                            <h2 class="site_title">
                                B&G LIBRARY
                            </h2>
                        </td>
                    </tr>
                </table>
            </div>
            <div class="col-md-2"></div>

        </div>
        <div class="navbar navbar-inverse">
            <div class="container">
                <div class="navbar-header">
                    <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                    </button>
                    @Html.ActionLink("Home", "Index", "Home", new { area = "" }, new { @class = "navbar-brand navbar-button" })
                </div>
                <div class="navbar-collapse collapse">
                    <ul class="nav navbar-nav">
                        <li class="navbar-button">@Html.ActionLink("Catalog", "Index", "Book")</li>
                    </ul>
                    <ul class="nav navbar-nav navbar-right">
                        <li class="navbar-button">@Html.ActionLink("Register", "Register", "Account")</li>
                        <li class="navbar-button">@Html.ActionLink("Log in", "Login", "Account")</li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="container body-content">
        @RenderBody()
        <hr />
        <footer>
            <p>&copy; @DateTime.Now.Year - B&G Library</p>
        </footer>
    </div>
    @Scripts.Render("~/bundles/jquery")
    @Scripts.Render("~/bundles/bootstrap")
    @RenderSection("scripts", required: false)
</body>
</html>

Biblioteka/Views/Shared/_LayoutAdmin.cshtml
@using Microsoft.AspNet.Identity;
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>@ViewBag.Title - My ASP.NET Application</title>
    @Styles.Render("~/Content/css")
    @Scripts.Render("~/bundles/modernizr")
</head>
<body>
    <div class="">
        <div class="main main_color ">
            <div class="col-md-2"></div>
            <div class="col-md-8">

                <table style="margin-left:10px;">
                    <tr>
                        <td>
                            <img src="/images/red_book.png" alt="Sample Photo" width="80" height="80" />
                        </td>
                        <td>
                            <h2 class="site_title">
                                B&G LIBRARY
                            </h2>
                        </td>
                    </tr>
                </table>
            </div>
            <div class="col-md-2"></div>

        </div>
        <div class="navbar navbar-inverse">
            <div class="container">
                <div class="navbar-header">
                    <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                    </button>
                    @Html.ActionLink("Home", "Index", "Home", new { area = "" }, new { @class = "navbar-brand navbar-button" })
                </div>
                <div class="navbar-collapse collapse">
                    <ul class="nav navbar-nav">
                    <li class="navbar-button">@Html.ActionLink("Books", "Index", "Book")</li>
                    <li class="navbar-button">@Html.ActionLink("Authors", "Index", "Author")</li>
                    <li class="navbar-button">@Html.ActionLink("Users", "Index", "Account")</li>
                    <li class="navbar-button">@Html.ActionLink("Notices", "IndexAdmin", "Notice")</li>
                    <li class="navbar-button">@Html.ActionLink("Limits", "Edit", "Limit")</li>
                    <li class="navbar-button">@Html.ActionLink("Notices", "IndexAdmin", "Notice")</li>

                    </ul>
                    <ul class="nav navbar-nav navbar-right">
                        <li class="dropdown">
                            <a class="dropdown-toggle" data-toggle="dropdown" href="#">
                                My Account
                                <span class="caret"></span>
                            </a>
                            <ul class="dropdown-menu" role="menu">
                                <li>@Html.ActionLink("Details", "Edit", "Account", new { id = Int32.Parse(this.User.Identity.GetUserId()) }, null)</li>
                                <li>@Html.ActionLink("Delete", "Delete", "Account", new { id = Int32.Parse(this.User.Identity.GetUserId()) }, null)</li>
                                <li>@Html.ActionLink("Logout", "LogOff", "Account")</li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
    </div>

    <div class="container body-content">
        @RenderBody()
        <hr />
        <footer>
            <p>&copy; @DateTime.Now.Year - My ASP.NET Application</p>
        </footer>
    </div>

    @Scripts.Render("~/bundles/jquery")
    @Scripts.Render("~/bundles/bootstrap")
    @RenderSection("scripts", required: false)
</body>
</html>

Biblioteka/Views/Shared/_LayoutEmployee.cshtml
@using Microsoft.AspNet.Identity;
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>@ViewBag.Title - My ASP.NET Application</title>
    @Styles.Render("~/Content/css")
    @Scripts.Render("~/bundles/modernizr")
</head>
<body>

    <div class="">
        <div class="main main_color ">
            <div class="col-md-2"></div>
            <div class="col-md-8">

                <table style="margin-left:10px;">
                    <tr>
                        <td>
                            <img src="/images/red_book.png" alt="Sample Photo" width="80" height="80" />
                        </td>
                        <td>
                            <h2 class="site_title">
                                B&G LIBRARY
                            </h2>
                        </td>
                    </tr>
                </table>
            </div>
            <div class="col-md-2"></div>

        </div>
        <div class="navbar navbar-inverse">
            <div class="container">
                <div class="navbar-header">
                    <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                    </button>
                    @Html.ActionLink("Home", "Index", "Home", new { area = "" }, new { @class = "navbar-brand navbar-button" })
                </div>
                <div class="navbar-collapse collapse">
                    <ul class="nav navbar-nav">
                        <li class="dropdown">
                            <a class="dropdown-toggle" data-toggle="dropdown" href="#">
                                Catalog
                                <span class="caret"></span>
                            </a>
                            <ul class="dropdown-menu" role="menu">
                                <li class="navbar-button">@Html.ActionLink("Books", "Index", "Book")</li>
                                <li class="navbar-button">@Html.ActionLink("Authors", "Index", "Author")</li>
                                <li class="navbar-button">@Html.ActionLink("Categories", "Index", "Category")</li>
                                <li class="navbar-button">@Html.ActionLink("Tags", "Index", "Tag")</li>

                            </ul>
                        </li>
                        <li class="navbar-button">@Html.ActionLink("Readers", "ReadersIndex", "Account")</li>
                        <li class="navbar-button">@Html.ActionLink("Reservations", "Index", "Reservation")</li>
                        <li class="navbar-button">@Html.ActionLink("Rentals", "Index", "Rental")</li>
                        <li class="navbar-button">@Html.ActionLink("Pendings", "Index", "Pending")</li>
                        <li class="navbar-button">@Html.ActionLink("Fines", "Index", "Fine")</li>
                        <li class="navbar-button">@Html.ActionLink("Notices", "IndexAdmin", "Notice")</li>

                    </ul>
                    <ul class="nav navbar-nav navbar-right">
                        <li class="dropdown">
                            <a class="dropdown-toggle" data-toggle="dropdown" href="#">
                                My Account
                                <span class="caret"></span>
                            </a>
                            <ul class="dropdown-menu" role="menu">
                                <li class="navbar-button">@Html.ActionLink("Details", "Edit", "Account", new { id = Int32.Parse(this.User.Identity.GetUserId()) }, new { @class = "navbar-button" })</li>
                                <li class="navbar-button">@Html.ActionLink("Delete", "Delete", "Account", new { id = Int32.Parse(this.User.Identity.GetUserId()) }, null)</li>
                                <li class="navbar-button">@Html.ActionLink("Logout", "LogOff", "Account")</li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
  
    <div class="container body-content">
        @RenderBody()
        <hr />
        <footer>
            <p>&copy; @DateTime.Now.Year - B&G Library</p>

        </footer>
    </div>

    @Scripts.Render("~/bundles/jquery")
    @Scripts.Render("~/bundles/bootstrap")
    @RenderSection("scripts", required: false)
</body>
</html>

Biblioteka/Views/Shared/_LayoutReader.cshtml
@using Microsoft.AspNet.Identity;
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>@ViewBag.Title - My ASP.NET Application</title>
    @Styles.Render("~/Content/css")
    @Scripts.Render("~/bundles/modernizr")
</head>
<body>
    <div class="">

        <div class="main main_color ">
            <div class="col-md-2"></div>
            <div class="col-md-8">

                <table style="margin-left:10px;">
                    <tr>
                        <td>
                            <img src="/images/red_book.png" alt="Sample Photo" width="80" height="80" />
                        </td>
                        <td>
                            <h2 class="site_title">
                                B&G LIBRARY
                            </h2>
                        </td>
                    </tr>
                </table>
            </div>
            <div class="col-md-2"></div>

        </div>

        <div class="navbar navbar-inverse">
            <div class="container">
                <div class="navbar-header">
                    <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                    </button>
                    @Html.ActionLink("Home", "Index", "Home", new { area = "" }, new { @class = "navbar-brand navbar-button" })
                </div>
                <div class="navbar-collapse collapse">
                    <ul class="nav navbar-nav">
                        <li class="navbar-button">@Html.ActionLink("Catalog", "Index", "Book")</li>
                        <li class="navbar-button">@Html.ActionLink("Cart", "Cart", "Account")</li>
                        <li class="navbar-button">@Html.ActionLink("My Books", "UserReservations", "Reservation")</li>
                        <li class="navbar-button">@Html.ActionLink("Contact", "Contact", "Home")</li>
                    </ul>
                    <ul class="nav navbar-nav navbar-right">
                        <li class="dropdown">
                            <a class="dropdown-toggle" data-toggle="dropdown" href="#">
                                My Account
                                <span class="caret"></span>
                            </a>
                            <ul class="dropdown-menu" role="menu">
                                <li>@Html.ActionLink("Details", "Edit", "Account", new { id = Int32.Parse(this.User.Identity.GetUserId()) }, null)</li>
                                <li>@Html.ActionLink("Delete", "Delete", "Account", new { id = Int32.Parse(this.User.Identity.GetUserId()) }, null)</li>
                                <li>@Html.ActionLink("Logout", "LogOff", "Account")</li>
                            </ul>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
        <div class="container body-content">
            @RenderBody()
            <hr />
            <footer>
                <p>&copy; @DateTime.Now.Year - B&G Library</p>

            </footer>
        </div>

        @Scripts.Render("~/bundles/jquery")
        @Scripts.Render("~/bundles/bootstrap")
        @RenderSection("scripts", required: false)
</body>
</html>